# -*- coding: utf-8 -*-
from setuphelpers import *

# Declaring global variables - Warnings: 1) WAPT context is only available in package functions; 2) Global variables are not persistent between calls
bin_name_x64 = "vcredist_x64.exe"
bin_name_x86 = "vcredist_x86.exe"
url_dl_x64 = "http://download.microsoft.com/download/1/6/B/16B06F60-3B20-4FF2-B699-5E9B7962F9AE/VSU_4/vcredist_x64.exe"
url_dl_x86 = "http://download.microsoft.com/download/1/6/B/16B06F60-3B20-4FF2-B699-5E9B7962F9AE/VSU_4/vcredist_x86.exe"


def update_package():
    print("Update/Download package content from upstream binary sources")

    # Getting proxy informations from WAPT settings
    proxy = {}
    if isfile(makepath(application_data(), "waptconsole", "waptconsole.ini")):
        proxywapt = inifile_readstring(makepath(user_local_appdata(), "waptconsole", "waptconsole.ini"), "global", "http_proxy")
        if proxywapt:
            proxy = {"http": proxywapt, "https": proxywapt}

    # Downloading binaries
    if not isfile(bin_name_x64):
        print("Downloading " + bin_name_x64)
        wget(url_dl_x64, bin_name_x64, proxies=proxy)

    if not isfile(bin_name_x86):
        print("Downloading " + bin_name_x86)
        wget(url_dl_x86, bin_name_x86, proxies=proxy)

    version = ".".join(get_file_properties(bin_name_x86)["ProductVersion"].split(".")[:3])

    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        result = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.version = "%s-%s" % (Version(version), control.version.split("-", 1)[-1])
    # control.set_software_version(version)
    control.save_control_to_wapt()
